/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/

/**************************************************************/
/* This file contains					      */
/* Help Context Identifiers for PROGRESS RESULTS	      */
/* embedded in PROGRESS pre-processor statements.	      */
/*                                                            */
/* The form used in this file is:			      */
/*							      */
/*	   <Name of the Help Topic>			      */
/*	   &GLOBAL-DEFINE <context-string> <context-number>   */
/*                                                            */
/* Please contact Documentation to make changes to this file. */
/* Thanks.                                                    */
/**************************************************************/

/**************************************************************
 * MODULE NAME: RESHLP.I
 *
 * MODULE DESCRIPTION: Include file for PROGRESS RESULTS.
 *
 * UTILIZED FUNCTIONS:
 *
 *   None
 *
 * UTILIZED VARIABLES/DEFINES:
 *
 *   None
 *
 * NOTES:
 *
 *   None
 *
 * DATE: 1/12/94
 * DESIGN ENGINEER: Gregory S. Rakauskas
 *
 **************************************************************/
/*
 * $Header: 
 */

/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Help Context Identifiers for PROGRESS RESULTS HELP V8.0A   */

/* RESULTS Help Contents screen */
&GLOBAL-DEFINE Contents_Main 0

/* RESULTS Window  (No Query) */
&GLOBAL-DEFINE PROGRESS_RESULTS_Window 13

/* RESULTS Window  (Browse) */
&GLOBAL-DEFINE PROGRESS_RESULTS_Window_Browse 14

/* RESULTS Window  (Export) */
&GLOBAL-DEFINE PROGRESS_RESULTS_Window_Export 15

/* RESULTS Window  (Form) */
&GLOBAL-DEFINE PROGRESS_RESULTS_Window_Form 16

/* RESULTS Window  (Label) */
&GLOBAL-DEFINE PROGRESS_RESULTS_Window_Label 17

/* RESULTS Window  (Report) */
&GLOBAL-DEFINE PROGRESS_RESULTS_Window_Report 18

/* Context-sensitive Dialog Boxes and Windows */

/* Query Information Dialog Box */
&GLOBAL-DEFINE Query_Description_Dlg_Box 147

/* Table Alias Dialog Box */
&GLOBAL-DEFINE Table_Alias_Dlg_Box 160

/* Add Calculated Field - Numeric Dialog Box */
&GLOBAL-DEFINE Add_Calc_Field_Func_Num_Dlg_Box 109

/* Add Calculated Field - Math Dialog Box */
&GLOBAL-DEFINE Add_Calc_Field_Func_Math_Dlg_Box 108

/* Add Calculated Field - Logical Dialog Box */
&GLOBAL-DEFINE Add_Calc_Field_Func_Log_Dlg_Box 103

/* Add Calculated Field - String Dialog Box */
&GLOBAL-DEFINE Add_Calc_Field_Func_Str_Dlg_Box 112

/* Add Calculated Field - Date Dialog Box */
&GLOBAL-DEFINE Add_Calc_Field_Func_Date_Dlg_Box 102

/* Available Tables Dialog Box */
&GLOBAL-DEFINE Available_Tables_Dlg_Box 119

/* Switch Related Table Dialog Box */
&GLOBAL-DEFINE Switch_Related_Table_Dlg_Box 294

/* Insert Field Dialog Box */
&GLOBAL-DEFINE Choose_Field_to_Insert_Dlg_Box 136

/* ASCII Codes Dialog Box */
&GLOBAL-DEFINE Control_Codes_Dlg_Box 118

/* Add Calculated Field - Counter Dialog Box */
&GLOBAL-DEFINE Define_Counters_Dlg_Box 101

/* Standard Export Dialog Box */
&GLOBAL-DEFINE Export_Types_Dlg_Box 157

/* Feature Editor Dialog Box */
&GLOBAL-DEFINE Feature_Editing_Dlg_Box 127

/* Field Delimiters Dialog Box */
&GLOBAL-DEFINE Field_Delimiters_Dlg_Box 130

/* Field Separators Dialog Box */
&GLOBAL-DEFINE Field_Separators_Dlg_Box 131

/* Form Frame Properties Dialog Box */
&GLOBAL-DEFINE Form_Frame_Properties_Dlg_Box 132

/* Browse Frame Properties Dialog Box */
&GLOBAL-DEFINE Browse_Frame_Properties_Dlg_Box 292

/* Headers and Footers Dialog Box */
&GLOBAL-DEFINE Headers_and_Footers_Dlg_Box 134

/* Insert Code After FOR EACH Dialog Box */
&GLOBAL-DEFINE Insert_Code_After_FOR_EACH_Dlg_Box 135

/* Custom Label Dialog Box */
&GLOBAL-DEFINE Label_Dimensions_Dlg_Box 121

/* Label Field Selection Dialog Box */
&GLOBAL-DEFINE Label_Field_Selection_Dlg_Box 139

/* Label Layout Dialog Box */
&GLOBAL-DEFINE Label_Layout_Dlg_Box 113

/* Add Calculated Field - Lookup Display Field Dialog Box */
&GLOBAL-DEFINE Lookup_Field_Display_Dlg_Box 105

/* Add Calculated Field - Lookup Matching Field Dialog Box */
&GLOBAL-DEFINE Select_Table_and_Field_Dlg_Box 106

/* Add Calculated Field - Lookup Source Field Dialog Box */
&GLOBAL-DEFINE Lookup_Field_Source_Dlg_Box 107

/* Master-Detail Dialog Box */
&GLOBAL-DEFINE Master_Detail_Dlg_Box 140

/* Menu Layout Dialog Box */
&GLOBAL-DEFINE Menu_Editor_Res_Dlg_Box 141

/* Open Dialog Box */
&GLOBAL-DEFINE Open_Dlg_Box 142

/* Integration Procedures Dialog Box */
&GLOBAL-DEFINE Options_Dlg_Box 137

/* Relationship Types Dialog Box */
&GLOBAL-DEFINE Outer_Joins_Dlg_Box 149

/* Page Break Dialog Box */
&GLOBAL-DEFINE Page_Ejects_Dlg_Box 143

/* Add Calculated Field - Percent of Total Dialog Box */
&GLOBAL-DEFINE Percent_of_Total_Dlg_Box 104

/* Print Preview Window */
&GLOBAL-DEFINE Print_Preview_Window 145

/* Properties Dialog Box */
&GLOBAL-DEFINE Properties_Dlg_Box 148

/* Record End Dialog Box */
&GLOBAL-DEFINE Record_End_Dlg_Box 150

/* Record Start Dialog Box */
&GLOBAL-DEFINE Record_Start_Dlg_Box 151

/* Table Relationships Dialog Box */
&GLOBAL-DEFINE Relationship_Editor_Dlg_Box 162

/* Custom Page Dialog Box */
&GLOBAL-DEFINE Report_Dimensions_Dlg_Box 122

/* Reset Dialog Box */
&GLOBAL-DEFINE Reset_Relations_Dlg_Box 153

/* Print to File Dialog Box */
&GLOBAL-DEFINE Run_Output_to_File_Dlg_Box 154

/* Save As Dialog Box */
&GLOBAL-DEFINE Save_As_Dlg_Box 155

/* Feature Security Dialog Box */
&GLOBAL-DEFINE Security_Dlg_Box 128

/* Sort Order Fields Dialog Box */
&GLOBAL-DEFINE Select_Sort_Order_Fields_Dlg_Box 156

/* Add/Remove Tables Dialog Box */
&GLOBAL-DEFINE Select_Tables_Dlg_Box 116

/* Add Calculated Field - Stacked Array Dialog Box */
&GLOBAL-DEFINE Stacked_Arrays_Dlg_Box 111

/* Aggregates Dialog Box */
&GLOBAL-DEFINE Totals_Dlg_Box 129

/* Totals Only Summary Dialog Box */
&GLOBAL-DEFINE Totals_Only_Summary_Dlg_Box 164

/* Delete Dialog Box */
&GLOBAL-DEFINE Delete_Queries_Dlg_Box 124

/* Standard Label Dialog Box */
&GLOBAL-DEFINE Label_Types_Dlg_Box 158

/* Add Calculated Field - Running Total Dialog Box */
&GLOBAL-DEFINE Running_Totals_Dlg_Box 110

/* Add/Remove Fields Dialog Box */
&GLOBAL-DEFINE Add_Remove_Fields_Dlg_Box 114

/* Tool Bar Layout Dialog Box */
&GLOBAL-DEFINE Toolbar_Editor_Dlg_Box 163

/* Deployment Dialog Box */
&GLOBAL-DEFINE Deployment_Dlg_Box 125

/* Preferences Dialog Box */
&GLOBAL-DEFINE Customize_Dlg_Box 144

/* Table Data Selection Dialog Box */
&GLOBAL-DEFINE Table_Restrictions_Dlg_Box 161

/* Standard Page Dialog Box */
&GLOBAL-DEFINE Report_Types_Dlg_Box 159

/* Application Rebuild Dialog Box */
&GLOBAL-DEFINE Application_Rebuild_Dlg_Box 117

/* Data Selection Dialog Box */
&GLOBAL-DEFINE Data_Selection_Dlg_Box 123

/* Join Construction Dialog Box */
&GLOBAL-DEFINE Join_Construction_Dlg_Box 138

/* Query By Example Dialog Box */
&GLOBAL-DEFINE QBE_Dlg_Box 146

/* How To Help Topic (call from Help menu) */
&GLOBAL-DEFINE How_To 2

/* Rename Field dialog box */
&GLOBAL-DEFINE Rename_Field_Dlg_Box 152

/* Data Governor dialog box */
&GLOBAL-DEFINE Data_Governor_Dlg_Box 133

/* Ask At Run Time Prompt dialog box */
&GLOBAL-DEFINE Ask_At_Run_Time_Prompt_Dlg_Box 126

/* RESULTS Converter Window */
&GLOBAL-DEFINE RESULTS_Converter_Window 295

/* Conversion Type dialog box */
&GLOBAL-DEFINE Conversion_Type_Dialog_Box 296

/* Convert Configuration dialog box */
&GLOBAL-DEFINE Convert_Configuration_Dlg_Box 297

/* Convert Query Directory dialog box */
&GLOBAL-DEFINE Convert_Query_Dir_Dlg_Box 298

/* reshlp.i - end of file */
