/** This utility will ensure that the smartobject the attribute is linked to is the same smartobject
    that the object instance is linked to
   
   ------------------------------------------------------------------------------------------------------ **/
disable triggers for dump of ryc_attribute_value.
disable triggers for load of ryc_attribute_value.  
   
DEFINE VARIABLE lError  AS LOGICAL    NO-UNDO.

DEFINE BUFFER ryc_attribute_value FOR ryc_attribute_value.
DEFINE BUFFER buf_attribute_value FOR ryc_attribute_value.
DEFINE BUFFER ryc_object_instance FOR ryc_object_instance.
DEFINE BUFFER ryc_smartobject     FOR ryc_smartobject.
DEFINE BUFFER buf_smartobject     FOR ryc_smartobject.

PUBLISH "DCU_WriteLog":U ("AttributeValue smartobject_obj fix started.").

FOR EACH ryc_attribute_value EXCLUSIVE-LOCK,
   FIRST ryc_object_instance NO-LOCK
   WHERE ryc_object_instance.object_instance_obj = ryc_attribute_value.object_instance_obj
     AND ryc_object_instance.smartobject_obj    <> ryc_attribute_value.smartobject_obj,
   FIRST ryc_smartobject NO-LOCK
   WHERE ryc_smartobject.smartobject_obj = ryc_object_instance.smartobject_obj:

  /* If we are going to violate the index, it means the attribute exists properly - against
     the correct smartobject. In this case, get rid of the 'duff' attribute */
  IF CAN-FIND(FIRST buf_attribute_value
              WHERE buf_attribute_value.object_type_obj     = ryc_smartobject.object_type_obj
                AND buf_attribute_value.smartobject_obj     = ryc_smartobject.smartobject_obj
                AND buf_attribute_value.object_instance_obj = ryc_attribute_value.object_instance_obj
                AND buf_attribute_value.render_type_obj     = ryc_attribute_value.render_type_obj
                AND buf_attribute_value.attribute_label     = ryc_attribute_value.attribute_label) THEN
  DO:
    DELETE ryc_attribute_value NO-ERROR.

    IF ERROR-STATUS:ERROR THEN
    DO:
      ASSIGN lError = TRUE.
      PUBLISH "DCU_WriteLog":U ("Unable to delete AttributeValue with attribute_value_obj '" + STRING(ryc_attribute_value.attribute_value_obj) + "'":U).

      ERROR-STATUS:ERROR = FALSE.
    END.
  END.
  ELSE
  DO:
    /* Fix the attribute */
    ASSIGN
        ryc_attribute_value.smartobject_obj = ryc_object_instance.smartobject_obj
        ryc_attribute_value.object_type_obj = ryc_smartobject.object_type_obj NO-ERROR.

    IF ERROR-STATUS:ERROR THEN
    DO:
      ASSIGN lError = TRUE.
      PUBLISH "DCU_WriteLog":U ("Unable to assign smartobject_obj to '" + STRING(ryc_object_instance.smartobject_obj) +
                                "' for AttributeValue with attribute_value_obj '" + STRING(ryc_attribute_value.attribute_value_obj) + "'":U).
  
      ERROR-STATUS:ERROR = FALSE.
    END.
  END.
END.

PUBLISH "DCU_WriteLog":U ("AttributeValue smartobject_obj fix completed " + (IF lError THEN "with errors!" ELSE "successfully.")).
