/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors: MIP Holdings (Pty) Ltd ("MIP")                       *
*               PSC                                                  *
*                                                                    *
*********************************************************************/

TRIGGER PROCEDURE FOR CREATE OF gsm_security_structure .

/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i
   Do not change manually. Customisations to triggers should be placed in separate
   include files pulled into the trigger. ICF auto generates write trigger custom
   include files. Delete or create customisation include files need to be created
   manually. Be sure to put the hook in ERwin directly so as not to have you changes
   overwritten.
   User defined Macro (UDP) Summary (case sensitive)
   gsm_security_structure           Expands to full table name, e.g. gsm_user
   %TableFLA            Expands to table unique code, e.g. gsmus
   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)
                        If defined, uses this field as the object field
                        If set to "none" then indicates table does not have an object field
   XYZ                  Do not define so we can compare against an empty string

   See docs for explanation of replication macros 
*/   

&SCOPED-DEFINE TRIGGER_TABLE gsm_security_structure
&SCOPED-DEFINE TRIGGER_FLA gsmss
&SCOPED-DEFINE TRIGGER_OBJ security_structure_obj


DEFINE BUFFER lb_table FOR gsm_security_structure.      /* Used for recursive relationships */
DEFINE BUFFER lb1_table FOR gsm_security_structure.     /* Used for lock upgrades */

DEFINE BUFFER o_gsm_security_structure FOR gsm_security_structure.

/* Standard top of CREATE trigger code */
{af/sup/aftrigtopc.i}

  



/* Generated by ICF ERwin Template */
/* ryc_smartobject uses gsm_security_structure ON CHILD INSERT SET NULL */
IF NOT(CAN-FIND(FIRST ryc_smartobject WHERE
    gsm_security_structure.object_obj = ryc_smartobject.smartobject_obj)) THEN
  DO:
    
    ASSIGN gsm_security_structure.object_obj = 0 .
  END.



/* Generated by ICF ERwin Template */
/* gsc_instance_attribute uses gsm_security_structure ON CHILD INSERT SET NULL */
IF NOT(CAN-FIND(FIRST gsc_instance_attribute WHERE
    gsm_security_structure.instance_attribute_obj = gsc_instance_attribute.instance_attribute_obj)) THEN
  DO:
    
    ASSIGN gsm_security_structure.instance_attribute_obj = 0 .
  END.



/* Generated by ICF ERwin Template */
/* gsc_entity_mnemonic is for gsm_security_structure ON CHILD INSERT RESTRICT */
IF 
    ( gsm_security_structure.owning_entity_mnemonic <> "":U ) THEN
  DO:
    IF NOT(CAN-FIND(FIRST gsc_entity_mnemonic WHERE
        gsm_security_structure.owning_entity_mnemonic = gsc_entity_mnemonic.entity_mnemonic)) THEN
        DO:
          /* Cannot create child because parent does not exist ! */
          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "gsm_security_structure|gsc_entity_mnemonic":U.
          RUN error-message (lv-errgrp, lv-errnum, lv-include).
        END.
    
    
  END.

/* Generated by ICF ERwin Template */
/* gsc_product_module uses gsm_security_structure ON CHILD INSERT SET NULL */
IF NOT(CAN-FIND(FIRST gsc_product_module WHERE
    gsm_security_structure.product_module_obj = gsc_product_module.product_module_obj)) THEN
  DO:
    
    ASSIGN gsm_security_structure.product_module_obj = 0 .
  END.








ASSIGN gsm_security_structure.{&TRIGGER_OBJ} = getNextObj() NO-ERROR.
IF ERROR-STATUS:ERROR THEN 
DO:
    ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 31 lv-include = "gsm_security_structure|the specified object number.  Please ensure your database sequences have been set correctly":U.
    RUN error-message (lv-errgrp, lv-errnum, lv-include).
END.







/* Update Audit Log */
IF CAN-FIND(FIRST gsc_entity_mnemonic
            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gsmss':U
              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN
  RUN af/app/afauditlgp.p (INPUT "CREATE":U, INPUT "gsmss":U, INPUT BUFFER gsm_security_structure:HANDLE, INPUT BUFFER o_gsm_security_structure:HANDLE).

/* Standard bottom of CREATE trigger code */
{af/sup/aftrigendc.i}


/* Place any specific CREATE trigger customisations here */
