/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* t-r-eng.p - English language definitions for Reports module */

{ prores/t-define.i }

DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.

IF qbf-s < 0 THEN RETURN.
qbf-lang = "".

IF qbf-s = 1 THEN
  ASSIGN
/*r-header.p*/
    qbf-lang[ 1] = '驫  壜  '
    qbf-lang[ 2] = '' /* must be < 8 characters */
                   /* 3..7 are format x(64) */
    qbf-lang[ 3] = '㩜   壜  囘  '
                 + 'ਫ਼'
    qbf-lang[ 4] = '~{COUNT~}         :  '
                 + '~{TIME~}   夞'
    qbf-lang[ 5] = '~{TODAY~}       :  '
                 + '~{NOW~}   ⮦ 騘'
    qbf-lang[ 6] = '~{PAGE~}  . ⮦ 囘 :  '
                 + '~{USER~}   㩫'
    qbf-lang[ 7] = '~{VALUE <>~;<>~}  㡞 '
                 + ' (㩫 [' + KBLABEL("GET") + '])'
    qbf-lang[ 8] = ' 妬  '
    qbf-lang[ 9] = '㩫 [' + KBLABEL("GO") + '] 㡜, ['
                 + KBLABEL("GET") + '] 㡞 妬, ['
                 + KBLABEL("END-ERROR") + '] ᡢ.'

/*r-total.p*/    /*"|---------------------------|"*/
    qbf-lang[12] = ' 夦  ᥜ:'
                 /*"|--------------------------------------------|"*/
    qbf-lang[13] = '    妬 ᢢ:'
                 /*"|---| |---| |---| |---| |---|" */
    qbf-lang[14] = '礦 ⫨.  ⚠ ⩞ '
    qbf-lang[15] = ' '
    qbf-lang[16] = ' :'
    qbf-lang[17] = ' 妬  '

/*r-calc.p*/
    qbf-lang[18] = ' 㢞  ⮦ 礦'
    qbf-lang[19] = ' 㢞    梦'
    qbf-lang[20] = '⮦ 礦'
    qbf-lang[21] = '% 梦'
    qbf-lang[22] = ',,,,'
    qbf-lang[23] = ''
    qbf-lang[24] = '驫   壞   '
    qbf-lang[25] = '驫  㣘 神     娜'
    qbf-lang[26] = ''
    qbf-lang[27] = ''
                 /*"------------------------------|"*/
    qbf-lang[28] = '           ' /*right justify*/
    qbf-lang[29] = '  㣘 神  ៜ ' /*right justify*/
    qbf-lang[32] = ' 㛞 婜  ⚠  .'.

ELSE

/*--------------------------------------------------------------------------*/
IF qbf-s = 2 THEN
  ASSIGN
/* r-space.p */  /*"------------------------------|  ---------|  |------"*/
    qbf-lang[ 1] = '                            ⮦  '
    /* 2..8 must be less than 32 characters long */
    qbf-lang[ 2] = ' 騠'
    qbf-lang[ 3] = '  '
    qbf-lang[ 4] = ' '
    qbf-lang[ 5] = '  囘'
    qbf-lang[ 6] = 'ਫ਼  ᤘ'
    qbf-lang[ 7] = '  ./⤦'
    qbf-lang[ 8] = '  ⤦/.'
                  /*1234567890123456789012345678901*/
    qbf-lang[ 9] = '㣘'
    qbf-lang[10] = '⧜  夜  ៜ  (1) ⮨   ⚜ 囘'
    qbf-lang[11] = ' ⧦  '
    qbf-lang[12] = '  婜  ਫ਼   㢞 1  '
    qbf-lang[13] = '  ⧜  夘   婠 !'
    qbf-lang[14] = '  婜  ਫ਼   髞   '

/*r-set.p*/        /* format x(30) for 15..22 */
    qbf-lang[15] = 'F.   /圪'
    qbf-lang[16] = 'P.  韞 囘'
    qbf-lang[17] = 'T.  ૠ ਫ਼'
    qbf-lang[18] = 'S.  㣘'
    qbf-lang[19] = 'LH.  囘'
    qbf-lang[20] = 'CH.  囘'
    qbf-lang[21] = 'RH.  囘'
    qbf-lang[22] = 'LF.  ਫ਼'
    qbf-lang[23] = 'CF.  ਫ਼'
    qbf-lang[24] = 'RF.  ਫ਼'
    qbf-lang[25] = 'FO. 囘 髞 .'
    qbf-lang[26] = 'LO. ਫ਼ . .'
    qbf-lang[32] = '㩫 [' + KBLABEL("END-ERROR")
                 + ']  ᤜ  .'.

ELSE

/*--------------------------------------------------------------------------*/
IF qbf-s = 3 THEN
  ASSIGN
    /* r-main.p,s-page.p */
    qbf-lang[ 1] = '. :,     :,     :,     :,     :'
    qbf-lang[ 2] = ':'
    qbf-lang[ 3] = ' ਫ਼'
    qbf-lang[ 4] = '嘩 ਫ਼'
    qbf-lang[ 5] = '' /* for <<more and more>> */
    qbf-lang[ 6] = '᫦,ਫ਼' /* each word comma-separated */
    qbf-lang[ 7] = '<  >  椫 婟  & '
    qbf-lang[ 8] = '礘   ਫ਼  ᫦   '
                 + '255 㨜'
    qbf-lang[ 9] = ' ⮜ 驜  ⮦ ਫ਼. '
                 + '⢜  婜; '
    qbf-lang[10] = ' ᣣ...'
    qbf-lang[11] = '"Compile"  ᣣ ਫ਼...'
    qbf-lang[12] = '⢜  ᣣ  㟞...'
    qbf-lang[13] = '礘     /ᛘ'
    qbf-lang[14] = 'ਫ਼ ਫ਼    ⮦ '
                 + 'ਫ਼'
    qbf-lang[15] = 'ਫ਼ 曦   ⮦ '
    qbf-lang[16] = '㩫 ['
                 + (IF KBLABEL("CURSOR-UP") BEGINS "CTRL-" THEN 'CURSOR-UP'
                   ELSE KBLABEL("CURSOR-UP"))
                 + ']  ['
                 + (IF KBLABEL("CURSOR-DOWN") BEGINS "CTRL-" THEN 'CURSOR-DOWN'
                   ELSE KBLABEL("CURSOR-DOWN"))
                 + ']  婟, ['
                 + KBLABEL("END-ERROR") + ']  ⢦.'
    qbf-lang[17] = '囘'
    qbf-lang[18] = '~{1~}   ਫ਼.'
    qbf-lang[19] = '礘    ૠ ਫ਼    '
                 + ' 棞 .'
    qbf-lang[20] = '礘    ૠ ਫ਼  '
                 + '樬 夘.'
    qbf-lang[21] = '椦 婜'
    qbf-lang[23] = '礘   ਫ਼    .'.

ELSE

/*--------------------------------------------------------------------------*/
/* FAST TRACK interface test for r-ft.p r-ftsub.p */
IF qbf-s = 4 THEN
  ASSIGN
    qbf-lang[ 1] = ' FAST TRACK  坜   曦   櫘 '
    qbf-lang[ 2] = ' 㩫 坜   騘 ⢜.   曦  PRINTER.'
    qbf-lang[ 3] = '  /驜...'
    qbf-lang[ 4] = '  ...'
    qbf-lang[ 5] = '   婜...'
    qbf-lang[ 6] = '   墫 WHERE...'
    qbf-lang[ 7] = '   驜...'
    qbf-lang[ 8] = '   ਫ਼...'
    qbf-lang[ 9] = 'ᨮ 㛞  ਫ਼   ~{1~}  FAST TRACK. '
                 + '⢜   篜; '
    qbf-lang[10] = '᢬ ਫ਼...'
    qbf-lang[11] = '⢜  ⩜  FAST TRACK; '
    qbf-lang[12] = '驫  '
    qbf-lang[13] = ' FAST TRACK  坜 TIME  囜/驜, '
                 + 'ᩫ  NOW.'
    qbf-lang[14] = ' FAST TRACK  坜    梦,   姜'
    qbf-lang[15] = ' FAST TRACK  坜 ~{1~}  囘/ਫ਼, '
                 + '~{2~} 姜.'
    qbf-lang[16] = '  ਫ਼   ⮜ 椦  㨜  '
                 + ' "_"'
    qbf-lang[17] = ' ਫ਼  FAST TRACK:'
    qbf-lang[18] = ' ਫ਼  ⨟  FAST TRACK'
    qbf-lang[19] = '⢜  FAST TRACK,  ⤜...'
    qbf-lang[20] = '⦤ ᚡ  囘/ਫ਼, '
                 + ' ਫ਼  ⨟.'
    qbf-lang[21] = ' FAST TRACK  坜 椦-髦/椦- 囜.'
                 + '姜.'
    qbf-lang[22] = ':   ~{1~} 㟞   .'
    qbf-lang[23] = ''
    qbf-lang[24] = 'TOTAL,COUNT,MAX,MIN,AVG'
    qbf-lang[25] = ' FAST TRACK  坜 ૠ 驜.'
                 + 'H ਫ਼  ⨟.'
    qbf-lang[26] = '礘   ਫ਼  FAST TRACK    '
                 + '  .'.


ELSE

/*--------------------------------------------------------------------------*/

IF qbf-s = 5 THEN
  ASSIGN
    /* r-short.p */
    qbf-lang[ 1] = ' ૠ ਫ਼ ᝜ 椦  '
                 + '.  ᩞ     婫 "棞", '
                 + '    餜 ៜ      ⛠ '
                 + '棞 ᝜.^  ⤞ ਫ਼,   ᣣ  '
                 + '餜 ៜ     ~{1~} ᝜.^⢜  婜 '
                 + ' ਫ਼ 驫  ᝜ 椦  婜; '
    qbf-lang[ 2] = ''
    qbf-lang[ 3] = ''
    qbf-lang[ 4] = '礘   "ૠ ਫ਼"   ⮜'
                 + '婜   夜  棞  .^^'
                 + '⥫ "棞"    驜  ⥫ '
                 + ' , 坦 祦  夦    ⤘ '
                 + '  驫    .'
    qbf-lang[ 5] = ' 婫 ⮜ 梘    ⮜ ⥜   '
                 + 'ਫ਼.'
    qbf-lang[ 6] = ' 婡 餜 櫠 椦     '
                 + '.'
    qbf-lang[ 7] = ' ⥜  ⛠, ⤘ 礦   '
                 + 'ៜ      妬 ~{1~}'
                 + '᝜.'
    qbf-lang[ 8] = ' ⥜ ⤘ - , ⤘   '
                 + ' 餦     ៜ ᛘ  ~{1~}.'
    qbf-lang[ 9] = ' 姫ਫ਼   ⥜ ,    妬 '
                 + '妬  ᛘ  .'

    /* r-page.p */
    qbf-lang[26] = '韞 囘'
    qbf-lang[27] = " 韞 囘"

    qbf-lang[28] = ' ᧦    '
    qbf-lang[29] = '᝜,  ਫ਼   '
    qbf-lang[30] = '   囘 棘.'
    qbf-lang[31] = '⥫      婫'
    qbf-lang[32] = '槦 ⢜  韞  囘.'.

/*--------------------------------------------------------------------------*/

RETURN.
