/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* t-s-eng.p - English language definitions for general system use */

{ prores/t-define.i }

DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.

IF qbf-s < 0 THEN RETURN.
qbf-lang = "".

/*--------------------------------------------------------------------------*/

/* l-edit.p,s-edit.p */
IF qbf-s = 1 THEN
  ASSIGN
    qbf-lang[ 1] = 'Lis'
    qbf-lang[ 2] = 'Haluatko varmasti lopettaa ilman muutosten tallettamista?'
    qbf-lang[ 3] = 'Kirjoita yhdistettvn tiedoston nimi'
    qbf-lang[ 4] = 'Kirjoita etsittv merkkijono'
    qbf-lang[ 5] = 'Valitse kentt'
    qbf-lang[ 6] = '[' + KBLABEL("GO") + '] = talletus, ['
		 + KBLABEL("GET") + '] = kentn lisys, ['
		 + KBLABEL("END-ERROR") + '] = peruutus.'
    qbf-lang[ 7] = 'Etsittv merkkijonoa ei lytynyt.'.

ELSE

/*--------------------------------------------------------------------------*/

/* s-ask.p,s-where.p */
IF qbf-s = 2 THEN
  ASSIGN
    qbf-lang[ 1] = 'Yhtsuuri'
    qbf-lang[ 2] = 'Erisuuri'
    qbf-lang[ 3] = 'Pienempi kuin'
    qbf-lang[ 4] = 'Pien. tai yht.'
    qbf-lang[ 5] = 'Suurempi kuin'
    qbf-lang[ 6] = 'Suur. tai yht.'
    qbf-lang[ 7] = 'Alkaa'
    qbf-lang[ 8] = 'Sislt'    /* must match [r.4.23] */
    qbf-lang[ 9] = 'Sopii maskiin'

    qbf-lang[10] = 'Valitse kentt'
    qbf-lang[11] = 'Lauseke'
    qbf-lang[12] = 'Syt arvo'
    qbf-lang[13] = 'Valitse vertailu' 

    qbf-lang[14] = 'Kysy kyttjlt arvoa ohjelman ajon aikana.'
    qbf-lang[15] = 'Syt ajoaikaisesti tehtv kysymys:'

    qbf-lang[16] = 'Kysy tietotyypin' /* data-type */
    qbf-lang[17] = 'arvo'

    qbf-lang[18] = '[' + KBLABEL("END-ERROR") + '] = lopetus,'
    qbf-lang[19] = '[' + KBLABEL("END-ERROR") + '] = viimeisen ehdon peruutus,'
    qbf-lang[20] = '[' + KBLABEL("GET") + '] = ehdon muokkaaminen.'

    qbf-lang[21] = 'Valitse kentlle tehtvn vertailun tyyppi.'

    qbf-lang[22] = 'Syt ~{1~} tieto verrattavaksi tiedon "~{2~}" kanssa.'
    qbf-lang[23] = 'Syt ~{1~} arvoksi tiedolle "~{2~}".'
    qbf-lang[24] = 'Paina [' + KBLABEL("PUT")
		 + '] arvon kysymiseksi ajon aikana.'
    qbf-lang[25] = 'Kysymyksen merkitys: ~{1~} on ~{2~} jokin ~{3~}.'

    qbf-lang[27] = 'Itse muokatussa ehdossa ei voi kytt arvon '
		 + 'kysymist ajon aikana.  Kyt vain toista.'
    qbf-lang[28] = 'Ei voi olla tuntematon arvo!'
    qbf-lang[29] = 'Syttk lis arvoja kentlle' /* '?' append to string */
    qbf-lang[30] = 'Syttk lis valintakriteerej?'
    qbf-lang[31] = 'Yhdisttk aikaisempiin kriteereihin?'
    qbf-lang[32] = 'Ehdon muokkaaminen'.

ELSE

/*--------------------------------------------------------------------------*/
IF qbf-s = 3 THEN
  ASSIGN
/* s-info.p, s-format.p */
    qbf-lang[ 1] = 'Lajittelu'  /* s-info.p automatically right-justifies */
    qbf-lang[ 2] = 'ja edelleen'    /*   1..9 and adds colons for you. */
    qbf-lang[ 3] = 'Taulu tai vast.'      /* but must fit in format x(24) */
    qbf-lang[ 4] = 'Relaatio'
    qbf-lang[ 5] = 'Jossa'
    qbf-lang[ 6] = 'Kentt'
    qbf-lang[ 7] = 'Lauseke'
    qbf-lang[ 9] = 'Piilota toistuvat arvot?'

    qbf-lang[10] = 'ALKAEN,LISYS,-'
    qbf-lang[11] = 'Et ole viel valinnut yhtn kentt!'
    qbf-lang[12] = 'Esitysmuoto ja otsikko'
    qbf-lang[13] = 'Esitysmuodot'
    qbf-lang[14] = 'Valitse kentt' /* also used by s-calc.p below */
    /* 15..18 must be format x(16) (see notes on 1..7) */
    qbf-lang[15] = 'Otsikko'
    qbf-lang[16] = 'Esitysmuoto'
    qbf-lang[17] = 'Tietokanta'
    qbf-lang[18] = 'Tietotyyppi'
    qbf-lang[19] = 'Viimeisen ajon kestoaika,minuuttia:sekunttia'
    qbf-lang[20] = 'Lausekkeella ei voi olla tuntematon arvo (?)'

/*s-calc.p*/ /* there are many more for s-calc.p, see qbf-s = 5 thru 8 */
/*s-calc.p also uses #14 */
    qbf-lang[27] = 'Lausekkeen muodostus'
    qbf-lang[28] = 'Lauseke'
    qbf-lang[29] = 'Listk viel tt lauseketta?'
    qbf-lang[30] = 'Valitse funktio'
    qbf-lang[31] = 'kuluvan pivn pivys'
    qbf-lang[32] = 'vakio'.

ELSE

/*--------------------------------------------------------------------------*/

IF qbf-s = 4 THEN
  ASSIGN
/*s-help.p*/
    qbf-lang[ 1] = 'Apua ei ole mritelty tlle valinnalle.'
    qbf-lang[ 2] = 'Apu'

/*s-order.p*/
    qbf-lang[15] = 'Nouseva/Laskeva' /*neither can be over 8 characters */
    qbf-lang[16] = 'Kirjoita "N" kentn nousevalle'
    qbf-lang[17] = '      ja "L" laskevalle lajittelulle.'

/*s-define.p*/
    qbf-lang[21] = 'F. Leveys/Kenttien muoto'
    qbf-lang[22] = 'K. Kentt'
    qbf-lang[23] = 'T. Taulut'
    qbf-lang[24] = 'S. Yhteis- ja vlisummat'
    qbf-lang[25] = 'Y. Kumulatiivinen'
    qbf-lang[26] = 'P. Prosentteja'
    qbf-lang[27] = 'C. Laskuri'
    qbf-lang[28] = 'M. Matemaattinen lauseke'
    qbf-lang[29] = 'T. Tekstimuotoinen lauseke'
    qbf-lang[30] = 'N. Numeerinen lauseke'
    qbf-lang[31] = 'D. Pivmrlauseke'
    qbf-lang[32] = 'L. Looginen lauseke'.

ELSE

/*--------------------------------------------------------------------------*/

/* s-calc.p - string expressions */
IF qbf-s = 5 THEN
  ASSIGN
    qbf-lang[ 1] = 's,Vakio tai kentt,s00=s24,~{1~}'
    qbf-lang[ 2] = 's,Osateksti,s00=s25n26n27,SUBSTRING(~{1~}'
		 + ';INTEGER(~{2~});INTEGER(~{3~}))'
    qbf-lang[ 3] = 's,Yhdist kaksi teksti,s00=s28s29,~{1~} + ~{2~}'
    qbf-lang[ 4] = 's,Yhdist kolme teksti,s00=s28s29s29,'
		 + '~{1~} + ~{2~} + ~{3~}'
    qbf-lang[ 5] = 's,Yhdist nelj teksti,s00=s28s29s29s29,'
		 + '~{1~} + ~{2~} + ~{3~} + ~{4~}'
    qbf-lang[ 6] = 's,Pienempi kahdesta tekstist,s00=s30s31,MINIMUM(~{1~};~{2~})'
    qbf-lang[ 7] = 's,Suurempi kahdesta tekstist,s00=s30s31,MAXIMUM(~{1~};~{2~})'
    qbf-lang[ 8] = 's,Tekstin pituus,n00=s32,LENGTH(~{1~})'
    qbf-lang[ 9] = 's,Kyttjtunnus,s00=,USERID("RESULTSDB")'
    qbf-lang[10] = 's,Aika,s00=,STRING(TIME;"HH:MM:SS")'

    qbf-lang[24]  = 'Valitse kentn nimi raporttisi sarakkeeksi tai valitse ' 
                  + '<<vakio>>, jos haluat raporttiisi vakiotekstin.'
    qbf-lang[25] = 'OSATEKSTI ottaa tekstist tulostukseen yhtenisen osan. '
		 + 'Valitse kentn nimi.'
    qbf-lang[26] = 'Syt osatekstin alun positio'
    qbf-lang[27] = 'Syt osatekstiin tulevien merkkien mr'
    qbf-lang[28] = 'Valitse ensimminen arvo'
    qbf-lang[29] = 'Valitse seuraava arvo'
    qbf-lang[30] = 'Valitse ensimminen verrattava'
    qbf-lang[31] = 'Valitse toinen verrattava'
    qbf-lang[32] = 'Numero tarkoittaa valitun tekstin pituutta.'.

ELSE

/*--------------------------------------------------------------------------*/

/* s-calc.p - numeric expressions */
IF qbf-s = 6 THEN
  ASSIGN
    qbf-lang[ 1] = 'n,Vakio tai kentt,n00=n26,~{1~}'
    qbf-lang[ 2] = 'n,Kahdesta numerosta pienempi,n00=n24n25,MINIMUM(~{1~};~{2~})'
    qbf-lang[ 3] = 'n,Kahdesta numerosta suurempi,n00=n24n25,MAXIMUM(~{1~};~{2~})'
    qbf-lang[ 4] = 'n,Jakojnns,n00=n31n32,~{1~} MODULO ~{2~}'
    qbf-lang[ 5] = 'n,Absoluuttinen arvo,n00=n27,'
		 + '(IF ~{1~} < 0 THEN - ~{1~} ELSE ~{1~})'
    qbf-lang[ 6] = 'n,Pyristys,n00=n28,ROUND(~{1~};0)'
    qbf-lang[ 7] = 'n,Katkaisu,n00=n29,TRUNCATE(~{1~};0)'
    qbf-lang[ 8] = 'n,Nelijuuri,n00=n30,SQRT(~{1~})'
    qbf-lang[ 9] = 'n,Nytt aikana,s00=n23,STRING(INTEGER(~{1~});"HH:MM:SS")'

    qbf-lang[23] = 'Valitse kentt, joka nytetn aikana, "HH:MM:SS"'
    qbf-lang[24] = 'Valitse ensimminen verrattava'
    qbf-lang[25] = 'Valitse toinen verrattava'
    qbf-lang[26] = 'Valitse kentt raporttisi sarakkeeksi tai valitse '
		 + '<<vakio>>, jos haluat raporttiisi vakionumeron.'
    qbf-lang[27] = 'Valitse kentt, jonka absoluuttinen (etumerkitn) arvo '
		 + 'nytetn.'
    qbf-lang[28] = 'Valitse kentt, joka pyristetn lhimpn kokonaislukuun.'
    qbf-lang[29] = 'Valitse kentt, joka pyristetn alaspin (desimaaliosa '
		 + 'poistetaan).'
    qbf-lang[30] = 'Valitse kentt, jonka nelijuuri lasketaan.'
    qbf-lang[31] = 'Kun numero on jaettu jakajalla, tst tulee '
		 + 'jakojnns.  Mist luvusta haluat jakojnnksen?'
    qbf-lang[32] = 'Mill jaetaan?'.

ELSE

/*--------------------------------------------------------------------------*/

/* s-calc.p - date expressions */
IF qbf-s = 7 THEN
  ASSIGN
    qbf-lang[ 1] = 'd,Nykypiv,d00=,TODAY'
    qbf-lang[ 2] = 'd,Lis pivi pivykseen,d00=d22n23,~{1~} + ~{2~}'
    qbf-lang[ 3] = 'd,Vhent pivi pivyksest,d00=d22n24,~{1~} - ~{2~}'
    qbf-lang[ 4] = 'd,Kahden pivyksen erotus,n00=d25d26,~{1~} - ~{2~}'
    qbf-lang[ 5] = 'd,Kahdesta pivyksest aikaisempi,d00=d20d21,MINIMUM(~{1~};~{2~})'
    qbf-lang[ 6] = 'd,Kahdesta pivyksest myhempi,d00=d20d21,MAXIMUM(~{1~};~{2~})'
    qbf-lang[ 7] = 'd,Kuukauden piv,n00=d27,DAY(~{1~})'
    qbf-lang[ 8] = 'd,Vuoden kuukausi,n00=d28,MONTH(~{1~})'
    qbf-lang[ 9] = 'd,Kuukauden nimi,s00=d29,ENTRY(MONTH(~{1~});"Tammikuu'
		 + ';Helmikuu;Maaliskuu;Huhtikuu;Toukokuu;Keskuu;Heinkuu;Elokuu;Syyskuu'
		 + ';Lokakuu;Marraskuu;Joulukuu")'
    qbf-lang[10] = 'd,Vuosi,n00=d30,YEAR(~{1~})'
    qbf-lang[11] = 'd,Viikonpiv,n00=d31,WEEKDAY(~{1~})'
    qbf-lang[12] = 'd,Viikonpivn nimi,s00=d32,ENTRY(WEEKDAY(~{1~});"'
		 + 'Sunnuntai;Maanantai;Tiistai;Keskiviikko;Torstai;Perjantai;Lauantai")'

    qbf-lang[20] = 'Valitse ensimminen verrattava'
    qbf-lang[21] = 'Valitse toinen verrattava'
    qbf-lang[22] = 'Valitse pivyskentt.'
    qbf-lang[23] = 'Valitse kentt, jossa on pivien lukumr listtvksi '
		 + 'thn pivykseen.'
    qbf-lang[24] = 'Valitse kentt, jossa on pivien lukumr vhennettvksi '
		 + 'tst pivyksest.'
    qbf-lang[25] = 'Vertaa kahta pivyst ja nytt niden erotuksen '
		 + 'piviss omana sarakkeenaan.  Valitse ensimminen '
		 + 'kentt.'
    qbf-lang[26] = 'Valitse nyt toinen pivyskentt.'
    qbf-lang[27] = 'Tm palauttaa kuukauden pivn numerona (1 - 31).'
    qbf-lang[28] = 'Tm palauttaa kuukauden numerona (1 - 12). '
    qbf-lang[29] = 'Tm palauttaa kuukauden nimen.'
    qbf-lang[30] = 'Tm palauttaa pivyksen vuoden numeron.'
    qbf-lang[31] = 'Tm palauttaa viikonpivn numeron, sunnuntai on 1.'
    qbf-lang[32] = 'Tm palauttaa viikonpivn nimen.'.

ELSE

/*--------------------------------------------------------------------------*/

/* s-calc.p - mathematical expressions */
IF qbf-s = 8 THEN
  ASSIGN
    qbf-lang[ 1] = 'm,Summa    (+) ,n00=n25n26m...,~{1~} + ~{2~}'
    qbf-lang[ 2] = 'm,Erotus   (-) ,n00=n25n27m...,~{1~} - ~{2~}'
    qbf-lang[ 3] = 'm,Tulo     (*),n00=n28n29m...,~{1~} * ~{2~}'
    qbf-lang[ 4] = 'm,Osamr (/),n00=n30n31m...,~{1~} / ~{2~}'
    qbf-lang[ 5] = 'm,Potenssiin korotus,n00=n25n32m...,EXP(~{1~};~{2~})'

    qbf-lang[25] = 'Syt ensimminen numero'
    qbf-lang[26] = 'Syt seuraava listtv numero'
    qbf-lang[27] = 'Syt seuraava vhennettv numero'
    qbf-lang[28] = 'Syt ensimminen kerrottava'
    qbf-lang[29] = 'Syt seuraava kerrottava'
    qbf-lang[30] = 'Syt jaettava'
    qbf-lang[31] = 'Syt jakaja'
    qbf-lang[32] = 'Syt potenssi'.

/*--------------------------------------------------------------------------*/

RETURN.
