/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* t-s-eng.p - English language definitions for general system use */

{ prores/t-define.i }

DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.

IF qbf-s < 0 THEN RETURN.
qbf-lang = "".

/*--------------------------------------------------------------------------*/

/* l-edit.p,s-edit.p */
IF qbf-s = 1 THEN
  ASSIGN
    qbf-lang[ 1] = 'Insert'
    qbf-lang[ 2] = 'ਫ਼ 曦  㡜'
    qbf-lang[ 3] = '驫    妬  餜'
    qbf-lang[ 4] = '驫  㨜  㫞'
    qbf-lang[ 5] = ' 妬  '
    qbf-lang[ 6] = '㩫 [' + KBLABEL("GO") + '] 㡜, ['
		 + KBLABEL("GET") + '] 㡞 妬, ['
		 + KBLABEL("END-ERROR") + '] ᡢ.'
    qbf-lang[ 7] = ' ⟞   㫞.'.

ELSE

/*--------------------------------------------------------------------------*/

/* s-ask.p,s-where.p */
IF qbf-s = 2 THEN
  ASSIGN
    qbf-lang[ 1] = '竘 '
    qbf-lang[ 2] = ' 竘 '
    qbf-lang[ 3] = '櫜 '
    qbf-lang[ 4] = '櫜  婦'
    qbf-lang[ 5] = '竜 '
    qbf-lang[ 6] = '竜  婦'
    qbf-lang[ 7] = '坜 '
    qbf-lang[ 8] = '⮜'    /* must match [r.4.23] */
    qbf-lang[ 9] = ' '

    qbf-lang[10] = ' 妬'
    qbf-lang[11] = 'ᥞ'
    qbf-lang[12] = '⥫ '
    qbf-lang[13] = '婜'

    qbf-lang[14] = '    㩫  騘 ⢜.'
    qbf-lang[15] = '驫  髞     騘 ⢜ :'

    qbf-lang[16] = '  ' /* data-type */
    qbf-lang[17] = ''

    qbf-lang[18] = '㩫 [' + KBLABEL("END-ERROR") + ']  ⢦.'
    qbf-lang[19] = '㩫 [' + KBLABEL("END-ERROR") + ']  ᡢ.'
    qbf-lang[20] = '㩫 [' + KBLABEL("GET") + ']   .'

    qbf-lang[21] = '⥫   皡   .'

    qbf-lang[22] = '驫  ,  ~{1~}  皡  "~{2~}".'
    qbf-lang[23] = '驫    ~{1~}  "~{2~}".'
    qbf-lang[24] = '㩫 [' + KBLABEL("PUT")
		 + ']     㩫  騘 ⢜.'
    qbf-lang[25] = '礫:  ~{1~} 夘 ~{2~} ᧦ ,  ~{3~}.'

    qbf-lang[27] = '    ᝜     '
		 + '  㩫  騘 ⢜. 㩫 椦  ⤘.'
    qbf-lang[28] = '  ⧜  夘 ੫ !'
    qbf-lang[29] = '驫 ᢢ  ' /* '?' append to string */
    qbf-lang[30] = '⢜  婜 ᢢ 㨠 ; '
    qbf-lang[31] = '    磜 㨠  夜 '
    qbf-lang[32] = ' '.

ELSE

/*--------------------------------------------------------------------------*/
IF qbf-s = 3 THEN
  ASSIGN
/* s-info.p, s-format.p */
    qbf-lang[ 1] = '棞 '  /* s-info.p automatically right-justifies */
    qbf-lang[ 2] = ' '    /*   1..9 and adds colons for you. */
    qbf-lang[ 3] = ''      /* but must fit in format x(24) */
    qbf-lang[ 4] = 'ૠ ⩞'
    qbf-lang[ 5] = ''
    qbf-lang[ 6] = ''
    qbf-lang[ 7] = 'ᥞ'
    qbf-lang[ 9] = 'ᢜ .; '

    qbf-lang[10] = ',,'
    qbf-lang[11] = ' ⮜ ⥜   !'
    qbf-lang[12] = '   圪'
    qbf-lang[13] = ''
    qbf-lang[14] = ' 妬' /* also used by s-calc.p below */
    /* 15..18 must be format x(16) (see notes on 1..7) */
    qbf-lang[15] = ''
    qbf-lang[16] = ''
    qbf-lang[17] = 'Database'
    qbf-lang[18] = '秦'
    qbf-lang[19] = '磜 椦 ⢜,:梜'
    qbf-lang[20] = '  ⧜  夘 ੫ (?)'

/*s-calc.p*/ /* there are many more for s-calc.p, see qbf-s = 5 thru 8 */
/*s-calc.p also uses #14 */
    qbf-lang[27] = ' '
    qbf-lang[28] = 'ᥞ'
    qbf-lang[29] = '  ⫝̸ ᢢ  ''  ᥞ; '
    qbf-lang[30] = ' 嘪'
    qbf-lang[31] = '  '
    qbf-lang[32] = ' '.

ELSE

/*--------------------------------------------------------------------------*/

IF qbf-s = 4 THEN
  ASSIGN
/*s-help.p*/
    qbf-lang[ 1] = ' ᨮ 㟜 ''  .'
    qbf-lang[ 2] = '㟜'

/*s-order.p*/
    qbf-lang[15] = '祦/夦' /*neither can be over 8 characters */
    qbf-lang[16] = '  ⤘ 驫 ""  祦 '
    qbf-lang[17] = ' ""  夦 .'

/*s-define.p*/
    qbf-lang[21] = 'W. ᫦/  '
    qbf-lang[22] = 'F. '
    qbf-lang[23] = 'A.  '
    qbf-lang[24] = 'T. 婣  礦'
    qbf-lang[25] = 'R. ⮦ 礦'
    qbf-lang[26] = 'P.   梦'
    qbf-lang[27] = 'C. '
    qbf-lang[28] = 'M.  ᥜ'
    qbf-lang[29] = 'S. ᥜ  '
    qbf-lang[30] = 'N. ᥜ  '
    qbf-lang[31] = 'D. ᥜ  圪'
    qbf-lang[32] = 'L.  ᥜ'.

ELSE

/*--------------------------------------------------------------------------*/

/* s-calc.p - string expressions */
IF qbf-s = 5 THEN
  ASSIGN
    qbf-lang[ 1] = 's,  ,s00=s24,~{1~}'
    qbf-lang[ 2] = 's,Substring,s00=s25n26n27,SUBSTRING(~{1~}'
		 + ';INTEGER(~{2~});INTEGER(~{3~}))'
    qbf-lang[ 3] = 's,  ,s00=s28s29,~{1~} + ~{2~}'
    qbf-lang[ 4] = 's,  ,s00=s28s29s29,'
		 + '~{1~} + ~{2~} + ~{3~}'
    qbf-lang[ 5] = 's,  ,s00=s28s29s29s29,'
		 + '~{1~} + ~{2~} + ~{3~} + ~{4~}'
    qbf-lang[ 6] = 's, 櫜  ,s00=s30s31,MINIMUM(~{1~};~{2~})'
    qbf-lang[ 7] = 's, 竜  ,s00=s30s31,MAXIMUM(~{1~};~{2~})'
    qbf-lang[ 8] = 's,㡦 ,n00=s32,LENGTH(~{1~})'
    qbf-lang[ 9] = 's, 㩫 (User ID),s00=,USERID("RESULTSDB")'
    qbf-lang[10] = 's,⮦ 騘,s00=,STRING(TIME;"HH:MM:SS")'

    qbf-lang[24] = '驫   妬      㢞 '
		 + ' ਫ਼  ⥫ << >>   ᢢ '
		 + '⤘    .'
    qbf-lang[25] = ' SUBSTRING  夜  櫞  驜 ⤘ '
		 + '㣘    ᤠ. ⥫  '
		 + ' 妬.'  
    qbf-lang[26] = '婫  髦 㨘  㣘  '
    qbf-lang[27] = '驫     ⢜  驜'
    qbf-lang[28] = '⥫  髞 '
    qbf-lang[29] = '⥫  棜 '
    qbf-lang[30] = '⥫  髦   皡'
    qbf-lang[31] = '⥫  竜   皡'
    qbf-lang[32] = '   夜   㡦  ⤦ '
		 + '.'.

ELSE

/*--------------------------------------------------------------------------*/

/* s-calc.p - numeric expressions */
IF qbf-s = 6 THEN
  ASSIGN
    qbf-lang[ 1] = 'n,  ,n00=n26,~{1~}'
    qbf-lang[ 2] = 'n, 櫜  ,n00=n24n25,MINIMUM(~{1~};~{2~})'
    qbf-lang[ 3] = 'n, 竜  ,n00=n24n25,MAXIMUM(~{1~};~{2~})'
    qbf-lang[ 4] = 'n,梦 娜 (MOD),n00=n31n32,~{1~} MODULO ~{2~}'
    qbf-lang[ 5] = 'n,梬 ,n00=n27,'
		 + '(IF ~{1~} < 0 THEN - ~{1~} ELSE ~{1~})'
    qbf-lang[ 6] = 'n,垩,n00=n28,ROUND(~{1~};0)'
    qbf-lang[ 7] = 'n,,n00=n29,TRUNCATE(~{1~};0)'
    qbf-lang[ 8] = 'n,ठ 坘,n00=n30,SQRT(~{1~})'
    qbf-lang[ 9] = 'n,ᤠ  騘,s00=n23,STRING(INTEGER(~{1~});"HH:MM:SS")'

    qbf-lang[23] = '⥫  ⛠  ᤠ  HH:MM:SS'
    qbf-lang[24] = '⥫  髦   皡'
    qbf-lang[25] = '  竜   皡'
    qbf-lang[26] = '驫   妬      㢞 '
		 + ' ਫ਼  ⥫ << >>   ᢜ '
		 + '   .'
    qbf-lang[27] = '⥫       梬  '
		 + '( 橞).'
    qbf-lang[28] = '⥫ ⤘    暚  ⩫ ⨘.'
    qbf-lang[29] = '⥫ ⤘    (娜   ⨦).'
    qbf-lang[30] = '⥫ ⤘     ठ 坘.'
    qbf-lang[31] = ' 梦  ᥞ : ⦪ / ⫞ = 塦 '
		 + '+ 梦.  驫  '
    qbf-lang[32] = '驫  ⫞'.

ELSE

/*--------------------------------------------------------------------------*/

/* s-calc.p - date expressions */
IF qbf-s = 7 THEN
  ASSIGN
    qbf-lang[ 1] = 'd, ,d00=,TODAY'
    qbf-lang[ 2] = 'd,㡞   ,d00=d22n23,~{1~} + ~{2~}'
    qbf-lang[ 3] = 'd,娜   ,d00=d22n24,~{1~} - ~{2~}'
    qbf-lang[ 4] = 'd,   ,n00=d25d26,~{1~} - ~{2~}'
    qbf-lang[ 5] = 'd, ⩫  ,d00=d20d21,MINIMUM(~{1~};~{2~})'
    qbf-lang[ 6] = 'd, ⩫  ,d00=d20d21,MAXIMUM(~{1~};~{2~})'
    qbf-lang[ 7] = 'd, ⨘  ,n00=d27,DAY(~{1~})'
    qbf-lang[ 8] = 'd, 㤘  ,n00=d28,MONTH(~{1~})'
    qbf-lang[ 9] = 'd,   㤘,s00=d29,ENTRY(MONTH(~{1~});"ᨠ'
		 + ';ᨠ;ᨫ;墠;䦪;礠;碠;皦;⣙'
		 + ';陨;⣙;⣙")'
    qbf-lang[10] = 'd,   ,n00=d30,YEAR(~{1~})'
    qbf-lang[11] = 'd, ⨘  ᛘ,n00=d31,WEEKDAY(~{1~})'
    qbf-lang[12] = 'd,   ⨘,s00=d32,ENTRY(WEEKDAY(~{1~});"'
		 + ';⨘;嫞;ᨫ;⣧;;ᙙ")'

    qbf-lang[20] = '⥫  髦   皡'
    qbf-lang[21] = '⥫  竜   皡'
    qbf-lang[22] = '⥫   嘪.'
    qbf-lang[23] = '⥫    ⮜     '
		 + '   .'
    qbf-lang[24] = '⥫    ⮜     '
		 + '    .'
    qbf-lang[25] = '皡     ᤠ 㢞  ⮜ '
		 + '   ,  ⨜.  ⥫  '
		 + '髦 .'
    qbf-lang[26] = '⥫  竜  嘪.'
    qbf-lang[27] = ' ⨘  㤘    '
		 + '1  31.'
    qbf-lang[28] = ' 㤘  ⫦    '
		 + '1  12.'
    qbf-lang[29] = '   㤘.'
    qbf-lang[30] = ' ⨦  ⫦  嘪  ⨘ .'
    qbf-lang[31] = '      ⨘,   夘 1.'
    qbf-lang[32] = '   ⨘  ᛘ.'.

ELSE

/*--------------------------------------------------------------------------*/

/* s-calc.p - mathematical expressions */
IF qbf-s = 8 THEN
  ASSIGN
    qbf-lang[ 1] = 'm,機,n00=n25n26m...,~{1~} + ~{2~}'
    qbf-lang[ 2] = 'm,娜,n00=n25n27m...,~{1~} - ~{2~}'
    qbf-lang[ 3] = 'm,,n00=n28n29m...,~{1~} * ~{2~}'
    qbf-lang[ 4] = 'm,娜,n00=n30n31m...,~{1~} / ~{2~}'
    qbf-lang[ 5] = 'm,ੜ  礘,n00=n25n32m...,EXP(~{1~};~{2~})'

    qbf-lang[25] = '驫  髦 '
    qbf-lang[26] = '驫  棜   機'
    qbf-lang[27] = '驫  棜   娜'
    qbf-lang[28] = '驫  '
    qbf-lang[29] = '驫  '
    qbf-lang[30] = '驫  '
    qbf-lang[31] = '驫  ⫞'
    qbf-lang[32] = '驫  礘'.

/*--------------------------------------------------------------------------*/

RETURN.
